/* ###################################
### MgnlGroovy.js
### This script requires jQuery (jquery.com) to work.
################################### */

var MgnlGroovy = {
    onSuccess : function(data) {
        this.running = false;
        var formattedData = $('<span></span>').text(data);
        var dataRows = formattedData.html().split(/\n/);
        data = '';
        tabs = '&nbsp;&nbsp;'
        for (row in dataRows) {
            data += '<span>' + dataRows[row].replace(/\t/g, tabs);
            if (!(row == dataRows.length - 1 && !dataRows[row])) {
                data += '<br />';
            }
            data += '</span>';
        }
        $('#consoleOutput').html(data)
    },

    onError : function(x, tStatus) {
        var out = 'ERROR: ';
        switch (tStatus) {
        case 'timeout':
            out += 'Server timeout. Try again later.';
            break;
        case 'notmodified':
            out += 'Server did not response properly. Try again.';
            break;
        case 'parsererror':
            out += 'Client error. Try again.';
            break;
        default:
        case 'error':
            out += 'A server error has occured. Error is ' + x.status + ': '
                    + x.statusText;
            if (x.status == 401)
                out += '\nPerhaps your session has expired. Try to login again.'
            else if (x.status == 0)
                out += '\nProbably server is down. Contact site administrator.'
        }
        return this.onSuccess(out);
    },

    runScript : function() {
        var url = contextPath + '/.magnolia/pages/groovyInteractiveConsole.html'
        var post_data = {}
        if (navigator.userAgent.match('Opera|AppleWebKit') == null){
            post_data['code'] = eval('text').getCode()
        } else {
            post_data['code'] = $('#text').val()
        }
        post_data['command'] = 'evaluateGroovy'
        $('#consoleOutput').html('Running script, please wait...')
        $.ajax( {
            'type' : 'post',
            'url' : url,
            'cache' : false,
            'data' : post_data,
            'dataType' : 'text',
            'success' : this.onSuccess,
            'error' : this.onError
        })
    }
}
